
%macro read;
  %do i= 1 %to 19;
      data dat&i;
           infile "\res_&i..dat";
           input d&i;
      run;
  %end;
%mend;
%read;

data dat;
      infile "o_res.dat";
      input d;
run;
 
proc iml;
   %macro red;
     %do i=1 %to 19;
             use dat&i var{d&i}; read all;
     %end;
   %mend;
   %red;
   n=nrow(d1);
  col=d1||d2||d3 ||d4 ||d5 ||d6 ||d7||d8 ||d9 ||d10 ||d11 ||d12 ||d13 ||d14 ||d15 ||d16 ||d17 ||d18 ||d19;
   
   dmin=col[,><];
   dmax=col[,<>];
   dmean=col[,+]/19;
   create res_dat var{dmin dmax dmean};
   append;
   quit;
   

data total; set res_dat; set dat;
     keep dmin dmax dmean d;
    run;

data try; set total nobs=nobs end=eof;
 _z_ = probit((_n_ + nobs - .125)/(2*nobs + .5));
label _z_='Expected value of half normal quantile'
                d="Absolute perason residual";
proc print data=try; run;

data crea; set try;
  file "for_splus19.dat";
  put d dmin dmax dmean _z_;
run;

proc gplot data=try;
        plot d  * _z_ = 1
             dmean * _z_ = 2
             dmin  * _z_ = 3
             dmax  * _z_ = 3 / overlay
                vaxis=axis1 frame vm=1 hm=1

          des="Half normal plot for pearson residual in 2-com. GLM";
        symbol1 v=star c=red i=non;
        symbol2 v=none    c=black  i=join;
        symbol3 v=none    c=gray60 i=join l=3;
        axis1 label=(a=90);
run; 
quit;



