function [mu]=getmu1(lp,bin)
% computes mean from 1st distribution from linear predictor based on the chosen 
% link function for that distribution (MU1LINK)

global MU1LINK OFFSET1;


if strcmp(MU1LINK,'logit')
  mu=bin.*exp(lp)./(1+exp(lp));
elseif strcmp(MU1LINK,'probit')
  mu=bin.*normcdf(lp);
elseif strcmp(MU1LINK,'log')
  mu=exp(lp);
elseif strcmp(MU1LINK,'inverse')
  mu=1./lp;
elseif strcmp(MU1LINK,'identity')
  mu=lp;
end;

