function [score_1, score_2]=oakes_delta(old_part1, old_part2,alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
% Calculates numerical derivative with respect to parm
% where parm is  (gamma',alpha', sigma(1), beta', sigma(2))'

global ID ID2 Y XMAT ZMAT WMAT N BINN1 BINN2 ERRDIST1 ERRDIST2 N2;
global MU1LINK MU2LINK PLINK;


dimalpha=size(alpha,1);
dimbeta=size(beta,1);
dimgamma=size(gamma,1);
dimparm=dimbeta+dimgamma+dimalpha+2;
mquad=size(quadwts,1);

NN=N*mquad;
ef=1.0e-16;

score_1=zeros(dimparm,1,NN);
score_2=zeros(dimparm,1,NN);

for j=1:dimgamma
    x=gamma(j);

    if (x~=0)
       h=x*ef^(1/2);
    else
       h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=gamma;
    farg2(j)=gamma(j)-h;
    [part_1, part_2]= oakes_part(alpha,beta,farg2,sigma,mquad,quadwts,quadvals);
    
    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=part_1(count);
                partxminush_2=part_2(count);

                score_1(j,1,count)=(old_part1(count)-partxminush_1)/(h);
                score_2(j,1,count)=(old_part2(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

for j=1:dimalpha

    x=alpha(j);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=alpha;
    farg2(j)=alpha(j)-h;

    [part_1, part_2] = oakes_part(farg2,beta,gamma,sigma,mquad,quadwts,quadvals);
  
    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=part_1(count);
                partxminush_2=part_2(count);

                score_1(dimgamma+j,1,count)=(old_part1(count)-partxminush_1)/(h);
                score_2(dimgamma+j,1,count)=(old_part2(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

    x=sigma(1);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=sigma;
    farg2(1)=sigma(1)-h;

    [part_1, part_2] = oakes_part(alpha,beta,gamma,farg2,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=part_1(count);
                partxminush_2=part_2(count);

                score_1(dimgamma+dimalpha+1,1,count)=(old_part1(count)-partxminush_1)/(h);
                score_2(dimgamma+dimalpha+1,1,count)=(old_part2(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i


for j=1:dimbeta

    x=beta(j);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;

    farg2=beta;
    farg2(j)=beta(j)-h;

    [part_1, part_2] = oakes_part(alpha,farg2,gamma,sigma,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=part_1(count);
                partxminush_2=part_2(count);

                score_1(dimgamma+dimalpha+1+j,1,count)=(old_part1(count)-partxminush_1)/(h);
                score_2(dimgamma+dimalpha+1+j,1,count)=(old_part2(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i
end; %j

    x=sigma(2);

    if (x~=0)
      h=x*ef^(1/2);
    else
      h=ef^(1/2);
    end;

    temp=x+h;
    h=temp-x;
    
    farg2=sigma;
    farg2(2)=sigma(2)-h;

    [part_1, part_2] = oakes_part(alpha,beta,gamma,farg2,mquad,quadwts,quadvals);

    count=0;
    for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
            
                partxminush_1=part_1(count);
                partxminush_2=part_2(count);

                score_1(dimgamma+dimalpha+1+dimbeta+1,1,count)=(old_part1(count)-partxminush_1)/(h);
                score_2(dimgamma+dimalpha+1+dimbeta+1,1,count)=(old_part2(count)-partxminush_2)/(h);
            end; %l
         end; %jj
     end; %i







