function [alpha,beta,gamma,sigma,converge,cov_oakes]=oem_oakes(alphainit,betainit,gammainit,sigmainit,mquad)
% fits mixture of two exponential family GLMs each with random intercept


% glmlab globals;
global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;

global Y ID ID2 N N2 XMAT ZMAT WMAT BINN1 BINN2 ERRDIST1 ERRDIST2 MU1LINK 
global MU2LINK PLINK OFFSET1 OFFSET2;

mquad
clear paramtrs;
[toler,maxits,illctol]=myparamtrs %load defaults
converge=0;

%Setup Gaussian quadratue
[quadwts,quadvals]=getgaussherm(mquad);
quadwts=quadwts./sqrt(3.14159265358979);
quadvals=sqrt(2).*quadvals;

alpha=alphainit;
beta=betainit;
gamma=gammainit;
sigma=sigmainit;

dimbeta=size(beta,1);
dimgamma=size(gamma,1);
dimalpha=size(alpha,1);
dimsigma=2;
dimparm=dimalpha+dimbeta+dimgamma+dimsigma;

its=0;
fail=0;

loglik= getloglik(alpha,beta,gamma,sigma,mquad,quadwts,quadvals)

while (its<maxits)

  emitcount=0;
  while (emitcount<5000) % do EM algorithm 5 times
    emitcount=emitcount+1
    its=its+1

    alphaold=alpha; 
    betaold=beta;
    gammaold=gamma;
    sigmaold=sigma;
  
    alp=OFFSET1+XMAT*alpha;
    blp=OFFSET2+ZMAT*beta;
    glp=WMAT*gamma;
    p=getmixp(glp);
    
    %M step for gamma
    warning off
    newmodel; 
    clear global YVAR XVARS;
    global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
    global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
    warning on
    NAMEXV='[';
    for i=1:size(WMAT,2)
      NAMEXV=strcat(NAMEXV,'G'); 
      NAMEXV=strcat(NAMEXV,int2str(i));
      if (i~=size(WMAT,2))
        NAMEXV=strcat(NAMEXV,',');
      end;
    end;
    NAMEXV=strcat(NAMEXV,']');
    NAMEYV='[y]';
    NAMELIST=['Constant'];
    for i=1:size(WMAT,2)-1
      NAMELIST=str2mat(NAMELIST,['Gvar ',num2str(i)]);
    end;

    INC_CONST=0;
  
    fofyijcond=zeros(N,mquad);
    mu1cond=zeros(N,mquad);
    mu2cond=zeros(N,mquad);
    u=zeros(N,mquad); 
    u1=zeros(N,1);
    for l=1:mquad
      mu1cond(:,l)=getmu1(alp+sigma(1)*quadvals(l),BINN1);
      mu2cond(:,l)=getmu2(blp+sigma(2)*quadvals(l),BINN2);
      temp= getf1cond(Y,mu1cond(:,l),BINN1).*p;
      fofyijcond(:,l)= temp+(1-p).*getf2cond(Y,mu2cond(:,l),BINN2);
      cc = temp+(1-p).*getf2cond(Y,mu2cond(:,l),BINN2);
      u1(cc==0) = zeros(size(cc(cc==0),1),1);
      u1(cc~=0) = temp(cc~=0)./cc(cc~=0);
      u(:,l)=u1;
      end;

    YVAR=[stackrows(u),ones(N*mquad,1)];
    LINKFUNCTION=PLINK;
    XVARS=kron(WMAT,ones(mquad,1));
    ERRDISFUNCTION='binoml';
    OFFSET=zeros(size(YVAR,1),1);
    WEIGHTS=zeros(size(YVAR,1),1);
    count1=0;
    count2=0;
    prodi=zeros(N2,mquad);
    for i=1:N2
      prodi(i,:)=prod(fofyijcond(ID==i,:)); %1 x mquad row vector
      ti=size(ID(ID==i),1);
      for j=1:ti;
        count2=count2+1;
        for l=1:mquad;
          count1=count1+1;
          WEIGHTS(count1)=prodi(i,l)*quadwts(l)/(prodi(i,:)*quadwts);
          WEIGHTS;
        end; % l
      end; % j
    end; % i

    WEIGHTS(isinf(WEIGHTS)|isnan(WEIGHTS))=0;
    
    [gamma, fits, resids, glmcovgamma, covd, devlist]=glmfit;
    gamma=gamma(:,1);


    % M step for alpha
    warning off
    newmodel; 
    clear global YVAR XVARS;
    global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
    global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
    warning on
    NAMEXV='[';
    for i=1:size(XMAT,2)+1
      NAMEXV=strcat(NAMEXV,'A'); 
      NAMEXV=strcat(NAMEXV,int2str(i));
      if (i~=size(XMAT,2))
        NAMEXV=strcat(NAMEXV,',');
      end;
    end;
    NAMEXV=strcat(NAMEXV,']');
    NAMEYV='[y]';
    NAMELIST=['Constant'];
    for i=1:size(XMAT,2)
      NAMELIST=str2mat(NAMELIST,['Avar ',num2str(i)]);
    end;

    if strcmp(ERRDIST1,'binoml')
      YVAR=kron([Y,BINN1],ones(mquad,1));
    else
      YVAR=kron([Y],ones(mquad,1));
    end;
    LINKFUNCTION=MU1LINK;
    XVARS=[ kron(XMAT,ones(mquad,1)), kron(ones(N,1),quadvals)];
    ERRDISFUNCTION=ERRDIST1;
    SCALEPAR=1;
    INC_CONST=0;
    OFFSET=kron(OFFSET1,ones(mquad,1));
    WEIGHTS=zeros(size(YVAR,1),1);
    count1=0;
    count2=0;
    for i=1:N2
      ti=size(ID(ID==i),1);
      for j=1:ti;
        count2=count2+1;
        for l=1:mquad;
          count1=count1+1;
          WEIGHTS(count1)=u(count2,l)*prodi(i,l)*quadwts(l)/(prodi(i,:)*quadwts);
        end; % l
      end; % j
    end; % i
    WEIGHTS(isinf(WEIGHTS)|isnan(WEIGHTS))=0;
    
    [alphatmp fits resids glmcovalpha covd devlist]=glmfit;
    alpha=alphatmp(1:size(XMAT,2),1);
    sigma(1)=alphatmp(end,1);


    % M step for beta
    warning off
    newmodel;
    clear global YVAR XVARS;
    global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
    global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
    warning on
    NAMEXV='[';
    for i=1:size(ZMAT,2)+1
      NAMEXV=strcat(NAMEXV,'B');
      NAMEXV=strcat(NAMEXV,int2str(i));
      if (i~=size(ZMAT,2))
        NAMEXV=strcat(NAMEXV,',');
      end;
    end;
    NAMEXV=strcat(NAMEXV,']');
    NAMEYV='[y]';
    NAMELIST=['Constant'];
    for i=1:size(ZMAT,2)
      NAMELIST=str2mat(NAMELIST,['Bvar ',num2str(i)]);
    end;

    if strcmp(ERRDIST2,'binoml')
      YVAR=kron([Y,BINN2],ones(mquad,1));
    else
      YVAR=kron([Y],ones(mquad,1));
    end;
    LINKFUNCTION=MU2LINK;
    XVARS=[ kron(ZMAT,ones(mquad,1)), kron(ones(N,1),quadvals)];
    ERRDISFUNCTION=ERRDIST2;
    SCALEPAR=1;
    INC_CONST=0;
    OFFSET=kron(OFFSET2,ones(mquad,1));
    WEIGHTS=zeros(size(YVAR,1),1);
    count1=0;
    count2=0;
    for i=1:N2
      ti=size(ID(ID==i),1);
      for j=1:ti;
        count2=count2+1;
        for l=1:mquad;
          count1=count1+1;
          WEIGHTS(count1)=(1-u(count2,l))*prodi(i,l)*quadwts(l)/(prodi(i,:)*quadwts);
        end; % l
      end; % j
    end; % i
    WEIGHTS(isinf(WEIGHTS)|isnan(WEIGHTS))=0;
 
    [betatmp fits resids glmcovbeta covd devlist]=glmfit;
    beta=betatmp(1:size(ZMAT,2),1);
    sigma(2)=betatmp(end,1);
  
    maxchange=max(abs([alpha-alphaold;beta-betaold;gamma-gammaold;sigma-sigmaold]))
    loglik= getloglik(alpha,beta,gamma,sigma,mquad,quadwts,quadvals)
  
    if (maxchange<toler)
      converge=1
      its=maxits+1;
    end;

    if (converge==1)
      emitcount=5000;
      minus2loglik=-2*loglik

      conexpfullhess= [inv(glmcovgamma), zeros(dimgamma,dimalpha+dimbeta+2);zeros(dimalpha+1,dimgamma), inv(glmcovalpha), zeros(dimalpha+1,dimbeta+1); zeros(dimbeta+1,dimgamma+dimalpha+1), inv(glmcovbeta)]

      [part_1, part_2]=oakes_part(alpha,beta,gamma,sigma,mquad,quadwts,quadvals);
      old_part1=part_1;
      old_part2=part_2;

      [score_1, score_2]=oakes_delta(old_part1, old_part2,alpha,beta,gamma,sigma,mquad,quadwts,quadvals);

      [uweight, weight]=oakes_weightu(alpha,beta,gamma,sigma,mquad,quadwts,quadvals);
      old_uw=uweight;
      old_w=weight;

      [uwscore_1, wscore_2]=oakes_delta_h(old_uw, old_w,alpha,beta,gamma,sigma,mquad,quadwts,quadvals);

   term1=zeros(dimparm, dimparm);
   term2=zeros(dimparm, dimparm);
   count=0;
   for i=1:N2 
        ti=size(ID(ID==i),1);
        for jj=1:ti
            for l=1:mquad
                count=count+1;
                result1=score_1(:,:,count)*uwscore_1(:,:,count);            
                term1=term1+result1;

                result2=score_2(:,:,count)*wscore_2(:,:,count);            
                term2=term2+result2;

            end; %l
         end; %jj
   end; %i
   oakes_2=term1+term2;
   info_oakes=conexpfullhess-oakes_2;  %(info=-(hess))

   cov_oakes=inv(info_oakes);      

    end; % if converge

  end; % while statement (5 EM steps)

  
 end;
