options ls=78;

data fly;
  infile "wflyid.dat";
  input Immatures week block trt binomdenom live plantid;
  y=live;
  n=binomdenom;
  w0=0;
  %macro indicator;
   %do i=2 %to 12; 
       w0=0;
       if week = &i then w0=1;
	   w&i=w0;
   %end;
   %do i=2 %to 3; 
       b0=0;
       if block = &i then b0=1;
	   b&i=b0;
   %end;
   %do i=1 %to 5; 
       t0=0;
       if trt = &i then t0=1;
	   t&i=t0;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 3;  
           tb0=0;
           if trt = &i and block = &j then tb0=1;
    	   tb&i.&j=tb0;
	   %end;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 12; 
           tw0=0;
           if trt = &i and week = &j then tw0=1;
    	   tw&i.&j=tw0;
	   %end;
   %end;
   %mend;
   %indicator;
   drop w0 t0 b0;

title " one-component GLMM"; 
proc nlmixed data=fly tech=nrridg MAXIT=800  instep=1e-5 gconv=1e-8[2] maxfunc=30000; 
   parms a1=-4.0996 ab2=1.1482 ab3=0.3270 at1=1.7608 at2=5.68 at3=1.8395 at4=4.2735 at5=5.6642 aw2=3.478 aw3=3.8 aw4=3.5764 aw5=2.9913 aw6=3.4716 aw7=2.6802 aw8=2.7259 aw9=3.0208 aw10=2.5492 aw11=3.1425 aw12=4.1015 th1=1;   
ef=1e-32;
  forpi1=a1+ab2*b2+ab3*b3+at1*t1+at2*t2+at3*t3+at4*t4+at5*t5+aw2*w2+aw3*w3+aw4*w4+aw5*w5+aw6*w6+aw7*w7+aw8*w8
       +aw9*w9+aw10*w10+aw11*w11+aw12*w12+th1*u1;  
  pi1=exp(forpi1)/(1+exp(forpi1));
  f1 = exp(lgamma(n+1)-lgamma(y+1)-lgamma(n-y+1)+y*log(pi1/(1-pi1))+n*log(1-pi1));
  ll=log(f1);
  model y~general(ll);
  random u1 ~ normal( 0,1) subject=plantid;
run;

