options ls=78;

data fly;
  infile "wflyid.dat";
  input Immatures week block trt binomdenom live plantid;
  y=live;
  n=binomdenom;
  w0=0;
  %macro indicator;
   %do i=2 %to 12; 
       w0=0;
       if week = &i then w0=1;
	   w&i=w0;
   %end;
   %do i=2 %to 3; 
       b0=0;
       if block = &i then b0=1;
	   b&i=b0;
   %end;
   %do i=1 %to 5; 
       t0=0;
       if trt = &i then t0=1;
	   t&i=t0;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 3;  
           tb0=0;
           if trt = &i and block = &j then tb0=1;
    	   tb&i.&j=tb0;
	   %end;
   %end;
   %do i=1 %to 5;
       %do j =2 %to 12; 
           tw0=0;
           if trt = &i and week = &j then tw0=1;
    	   tw&i.&j=tw0;
	   %end;
   %end;
   %mend;
   %indicator;
   drop w0 t0 b0;

run;

*proc print data=fly; run;

title "ZIB model----code it using log(gamma) etc";

proc nlmixed data=fly ebopt tech=CONGRA instep=1e-5  gconv=1e-8[2] maxfunc=30000;
parms a1=0.0213  at1=-1.7287 at2=-1.4681 at3=-1.898 at4=-1.1688 at5=2.48 ab2=0.4275 ab3=-0.0134
 aw2=0.5187 aw3=-0.3968 aw4=0.5182 aw5=-0.4087 aw6=-0.1049 aw7=-0.7411 aw8=0.0443 aw9=-0.8183
 aw10=-0.2401 aw11=-0.4817 aw12=0.6892   
  b1=-0.3068 bt1=-0.0622 bt2=0.24 bt3=0.2388 bt4=0.5195 bt5=-3.4266 bb2=0.0892 bb3=0.0781
 bw2=-0.3651 bw3=-0.5033 bw4=0.5924 bw5=1.178 bw6=1.159 bw7=0.1918 bw8=0.4592 bw9=0.868 
bw10=0.4171 bw11=0.5803 bw12=-0.3405;

ef=1e-32;
  forpi=a1+ at1*t1+at2*t2+at3*t3+at4*t4+at5*t5  +  ab2*b2+ab3*b3  +  aw2*w2+aw3*w3+aw4*w4+aw5*w5+aw6*w6+aw7*w7+aw8*w8
       +aw9*w9+aw10*w10+aw11*w11+aw12*w12;

  forp=b1+ bt1*t1+bt2*t2+bt3*t3+bt4*t4+bt5*t5  +  bb2*b2+bb3*b3  +  bw2*w2+bw3*w3+bw4*w4+bw5*w5+bw6*w6+bw7*w7+bw8*w8
       +bw9*w9+bw10*w10+bw11*w11+bw12*w12;
  p=exp(forp)/(1+exp(forp));
  pi=exp(forpi)/(1+exp(forpi));
  if (y=0) then f1=p+(1-p)*(1-pi)**n;
  else if (y ne 0) then  f1=(1-p)*exp(lgamma(n+1)-lgamma(y+1)-lgamma(n-y+1)+y*log(pi/(1-pi))+n*log(1-pi));
  ll=log(f1);
  model y~general(ll);
run;
